package classes;

import java.io.File;
import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.*;

public class Database {

    //static reference to itself
    private static Database dbIsntance;
    public static final String URL = "jdbc:mysql://localhost";
    public static final String USER = "davide";
    public static final String PASSWORD = "davide";
    public static final String DRIVER_CLASS = "com.mysql.jdbc.Driver";

    private static Connection con;
    private static Statement stmt;

    private Database() {
        /* private constructor*/ }

    public static Database getInstance() {
        if (dbIsntance == null) {
            dbIsntance = new Database();
        }
        return dbIsntance;
    }

    public Connection getConnection(String database) {

        if (con == null) {
            try {
                Class.forName(DRIVER_CLASS);
                con = DriverManager.getConnection(URL + "/" + database, USER, PASSWORD);
            } catch (SQLException | ClassNotFoundException ex) {
                Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        return con;
    }

    public ArrayList<String> getMD(String tableName) throws SQLException {

        DatabaseMetaData dbmd = con.getMetaData();
        ResultSet rs = dbmd.getColumns(null, null, tableName, "%");

        ArrayList<String> arr_type = new ArrayList<String>();

        while (rs.next()) {
            String c_name = rs.getString("COLUMN_NAME");
            String c_type = rs.getString("TYPE_NAME");
            arr_type.add(c_type);
            System.out.println("c_name: " + c_name + ", c_type: " + c_type);
        }
        return arr_type;
    }

    public void insertRow(String table, ArrayList<String> tuple)
            throws SQLException {

        try {
            ArrayList<String> md = this.getMD(table);

            String query = "INSERT INTO " + table + " VALUES(";
            for (int i = 0; i < md.size() - 1; i++) {
                query += "?,";
            }
            query += "?)";

            System.out.println(query);

            con.setAutoCommit(false);
            PreparedStatement pstmt = con.prepareStatement(query);

            int i = 0;
            for (int j = 1; j <= md.size(); j++, i++) {
                if (md.get(j - 1).equals("VARCHAR")) {
                    pstmt.setString(j, tuple.get(i));
                } else if (md.get(j - 1).equals("DATE")) {
                } else if (md.get(j - 1).equals("NUMBER")) {
                } else {
                }
            }
            pstmt.executeUpdate();
            con.commit();
            con.setAutoCommit(true);
        } catch (SQLException ex) {
            con.rollback();
            Logger.getLogger(Database.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public int checkUser(String mail, String password) throws SQLException {

        String cc = null;

        Statement stat = (Statement) con.createStatement();

        String query = "SELECT COUNT(*) "
                + "FROM users "
                + "WHERE mail=" + "'" + mail + "' AND PASSWORD=" + "'" + password + "'";

        ResultSet rest = stat.executeQuery(query);

        while (rest.next()) {
            cc = rest.getString(1);
        }

        System.out.println(cc);

        stat.close();
        rest.close();

        return Integer.parseInt(cc);
    }

    public Map<String, String> getInfo(String table, String attr, String attrVal) throws SQLException {

        String out = null;

        Statement stat = (Statement) con.createStatement();
        Map<String, String> info = new HashMap<String, String>();

        String query = "SELECT * "
                + "FROM " + table + " "
                + "WHERE " + attr + "=" + "'" + attrVal + "'";

        ResultSet rest = stat.executeQuery(query);

        ResultSetMetaData rsmd = rest.getMetaData();
        int columnsNumber = rsmd.getColumnCount();

        while (rest.next()) {
            for (int i = 1; i <= columnsNumber; i++) {
                info.put(rsmd.getColumnLabel(i), rest.getString(i));
            }
        }

        System.out.println(info);

        return info;
    }

    public ArrayList<Map<String, String>> getAllRows(String table) throws SQLException {

        Statement stat = (Statement) con.createStatement();

        String query = "SELECT * "
                + "FROM " + table;

        ArrayList<Map<String, String>> out = new ArrayList<Map<String, String>>();

        ResultSet rest = stat.executeQuery(query);

        ResultSetMetaData rsmd = rest.getMetaData();
        int columnsNumber = rsmd.getColumnCount();

        while (rest.next()) {
            Map<String, String> tmp = new HashMap<String, String>();
            for (int i = 1; i <= columnsNumber; i++) {
                tmp.put(rsmd.getColumnLabel(i), rest.getString(i));
            }
            out.add(tmp);
        }

        System.out.println(out);

        return out;
    }

}
